/*
** Module   : CommonField.java
** Abstract : Define getters and setters for various widget and field common attributes.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CA  20130220 Created initial version.
** 002 EVL 20130911 Adding legacy attributes and methods annotation.
*/

package com.goldencode.p2j.util;

/**
 * Defines setters and getters for the FORMAT, COLUMN-LABEL, DATA-TYPE and LABEL attributes. 
 */
public interface CommonField
{
   /**
    * Getter of FORMAT attribute.
    *
    * @return   current value of FORMAT attribute.
    */
   @LegacyAttribute(name = "FORMAT")
   public character getFormat();

   /**
    * Setter of FORMAt attribute.
    *
    * @param   format
    *          The new value.
    */
   @LegacyAttribute(name = "FORMAT", setter = true)
   public void setFormat(character format);

   /**
    * Setter of FORMAt attribute.
    *
    * @param   format
    *          The new value.
    */
   @LegacyAttribute(name = "FORMAT", setter = true)
   public void setFormat(String format);

   /**
    * Getter of COLUMN-LABEL attribute.
    *
    * @return   current value of COLUMN-LABEL attribute.
    */
   @LegacyAttribute(name = "COLUMN-LABEL")
   public character getColumnLabel();

   /**
    * Setter of COLUMN-LABEL attribute.
    * 
    * @param    columnLabel
    *           New value of a attribute.
    */
   @LegacyAttribute(name = "COLUMN-LABEL", setter = true)
   public void setColumnLabel(character columnLabel);

   /**
    * Setter of COLUMN-LABEL attribute.
    * 
    * @param    columnLabel
    *           New value of a attribute.
    */
   @LegacyAttribute(name = "COLUMN-LABEL", setter = true)
   public void setColumnLabel(String columnLabel);
 
   /**
    * Returns the value of the DATA-TYPE attribute
    *
    * @return   Current value of the DATA-TYPE attribute.
    */
   @LegacyAttribute(name = "DATA-TYPE")
   public character getDataType();
 
   /**
    * Set the <code>DATA-TYPE</code> attribute..
    *
    * @param    dataType
    *           The DATA-TYPE to be set.
    */
   @LegacyAttribute(name = "DATA-TYPE", setter = true)
   public void setDataType(String dataType);

   /**
    * Set the <code>DATA-TYPE</code> attribute..
    *
    * @param    dataType
    *           The DATA-TYPE to be set.
    */
   @LegacyAttribute(name = "DATA-TYPE", setter = true)
   public void setDataType(character dataType); 

   /**
    * Returns the value of the LABEL attribute
    *
    * @return    Current value of the LABEL attribute.
    */
   @LegacyAttribute(name = "LABEL")
   public character getLabel();

   /**
    * Set the <code>LABEL</code> attribute of handle.
    *
    * @param    label
    *           The LABEL to be set.
    */
   @LegacyAttribute(name = "LABEL", setter = true)
   public void setLabel(String label);

   /**
    * Set the <code>LABEL</code> attribute of handle.
    *
    * @param    label
    *           The LABEL to be set.
    */
   @LegacyAttribute(name = "LABEL", setter = true)
   public void setLabel(character label);
}
